package org.ow2.bonita.connector.core;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MultiInstantiatorInstantiator extends MultipleInstancesInstantiator {

  private MultiInstantiator instantiator;
  private Map<String, Object[]> instantiatorParameters;
  private String className;
  private String variableName;

  public Map<String, Object[]> getInstantiatorParameters() {
    return instantiatorParameters;
  }

  public void setInstantiator(MultiInstantiator instantiator) {
    this.instantiator = instantiator;
  }

  public void setInstantiatorParameters(Map<String, Object[]> instantiatorParameters) {
    this.instantiatorParameters = instantiatorParameters;
  }

  public void setInstantiatorParameters(List<List<Object>> instantiatorParameters) {
    this.instantiatorParameters = bonitaListToArrayMap(instantiatorParameters, String.class, Object.class);
  }
  
  public void setClassName(String className) {
    this.className = className;
  }

  public String getClassName() {
    return this.className;
  }

  public void setVariableName(String variableName) {
    this.variableName = variableName;
  }

  @Override
  protected List<Map<String, Object>> defineActivitiesContext() throws Exception {
    List<Map<String, Object>> contexts = new ArrayList<Map<String,Object>>();
    instantiator.execute();
    List<Object> values = instantiator.getVariableValues();
    for (Object value : values) {
      Map<String, Object> context = new HashMap<String, Object>();
      context.put(variableName, value);
      contexts.add(context);
    }
    return contexts;
  }

}
