/**
 * Copyright (C) 2010  BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.def;

import org.ow2.bonita.definition.activity.ExternalActivity;
import org.ow2.bonita.facade.def.majorElement.ActivityDefinition;
import org.ow2.bonita.facade.def.majorElement.impl.ActivityDefinitionImpl;
import org.ow2.bonita.runtime.model.ObjectReference;
import org.ow2.bonita.util.BonitaRuntimeException;
import org.ow2.bonita.util.ExceptionManager;

public class InternalActivityDefinition extends ActivityDefinitionImpl {

  private static final long serialVersionUID = 7575413369114996514L;

  public ObjectReference<ExternalActivity> behaviourReference;
	
  //mandatory for hibernate
  protected InternalActivityDefinition() {}

  public InternalActivityDefinition(ActivityDefinition activity, ExternalActivity behaviour) {
    super(activity);
    behaviourReference = new ObjectReference<ExternalActivity>(behaviour);
  }
  
  public ExternalActivity getBehaviour() {
    ExternalActivity behaviour = (behaviourReference != null ? behaviourReference.get() : null);
    if (behaviour == null) {
    	String message = ExceptionManager.getInstance().getFullMessage("bp_NI_1", this);
      throw new BonitaRuntimeException(message);
    }
    return behaviour;
  }

}
