/**
 * Copyright (C) 2010  BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.ejb;

import java.rmi.RemoteException;
import java.util.Date;
import java.util.List;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import org.ow2.bonita.facade.impl.StandardInternalAPIAccessorImpl;
import org.ow2.bonita.facade.internal.InternalBAMAPI;

public class BAMAPIBean implements InternalBAMAPI, SessionBean {

  private static final long serialVersionUID = 8977547453867812345L;
  
  protected SessionContext ctx = null;
  protected InternalBAMAPI bamAPI;

  protected InternalBAMAPI getAPI() {
    EJB2SecurityOwner.setUser(this.ctx.getCallerPrincipal().getName());
    if (this.bamAPI == null) {
      this.bamAPI = new StandardInternalAPIAccessorImpl().getBAMAPI();
    }
    return this.bamAPI;
  }
  
  public List<Integer> getNumberOfExecutingCasesPerDay(Date since, String queryList) throws RemoteException {
    return getAPI().getNumberOfExecutingCasesPerDay(since, queryList);
  }

  public List<Integer> getNumberOfFinishedCasesPerDay(Date since, String queryList) throws RemoteException {
    return getAPI().getNumberOfFinishedCasesPerDay(since, queryList);
  }

  public int getNumberOfOpenSteps(String queryList) throws RemoteException {
    return getAPI().getNumberOfOpenSteps(queryList);
  }

  public List<Integer> getNumberOfOpenStepsPerDay(Date since, String queryList) throws RemoteException {
    return getAPI().getNumberOfOpenStepsPerDay(since, queryList);
  }

  public int getNumberOfOverdueSteps(String queryList) throws RemoteException {
    return getAPI().getNumberOfOverdueSteps(queryList);
  }

  public int getNumberOfStepsAtRisk(int remainingDays, String queryList) throws RemoteException {
    return getAPI().getNumberOfStepsAtRisk(remainingDays, queryList);
  }

  public int getNumberOfUserOpenSteps(String queryList) throws RemoteException {
    return getAPI().getNumberOfUserOpenSteps(queryList);
  }

  public int getNumberOfUserOverdueSteps(String queryList) throws RemoteException {
    return getAPI().getNumberOfUserOverdueSteps(queryList);
  }

  public int getNumberOfUserStepsAtRisk(int remainingDays, String queryList) throws RemoteException {
    return getAPI().getNumberOfUserStepsAtRisk(remainingDays, queryList);
  }

  public void ejbCreate() {
  }
  
  public void ejbActivate() throws RemoteException {

  }

  public void ejbPassivate() throws RemoteException {

  }

  public void ejbRemove() throws RemoteException {

  }

  public void setSessionContext(SessionContext arg0) throws RemoteException {
    this.ctx = arg0;
  }

  public int getNumberOfFinishedSteps(int priority, Date since, String queryList)
      throws RemoteException {
    return getAPI().getNumberOfFinishedSteps(priority, since, queryList);
  }

  public int getNumberOfOpenSteps(int priority, String queryList) throws RemoteException {
    return getAPI().getNumberOfOpenSteps(priority, queryList);
  }

  public int getNumberOfUserFinishedSteps(int priority, Date since, String queryList) throws RemoteException {
    return getAPI().getNumberOfUserFinishedSteps(priority, since, queryList);
  }

  public int getNumberOfUserOpenSteps(int priority, String queryList) throws RemoteException {
    return getAPI().getNumberOfUserOpenSteps(priority, queryList);
  }
}
