/**
 * Copyright (C) 2010  BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.ejb;

import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import org.ow2.bonita.facade.RepairAPI;
import org.ow2.bonita.facade.exception.ActivityNotFoundException;
import org.ow2.bonita.facade.exception.InstanceNotFoundException;
import org.ow2.bonita.facade.exception.ProcessNotFoundException;
import org.ow2.bonita.facade.exception.VariableNotFoundException;
import org.ow2.bonita.facade.impl.StandardAPIAccessorImpl;
import org.ow2.bonita.facade.internal.InternalRepairAPI;
import org.ow2.bonita.facade.runtime.InitialAttachment;
import org.ow2.bonita.facade.uuid.ActivityInstanceUUID;
import org.ow2.bonita.facade.uuid.ProcessDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;

public class RepairAPIBean implements InternalRepairAPI, SessionBean {

  private static final long serialVersionUID = 6177826340900428744L;

  protected SessionContext ctx = null;

  protected RepairAPI repairAPI;

  protected RepairAPI getAPI() {
    EJB2SecurityOwner.setUser(this.ctx.getCallerPrincipal().getName());
    if (this.repairAPI == null) {
      this.repairAPI = new StandardAPIAccessorImpl().getRepairAPI();
    }
    return this.repairAPI;
  }

  public void ejbCreate() {

  }

  public void ejbActivate() throws RemoteException {

  }

  public void ejbPassivate() throws RemoteException {

  }

  public void ejbRemove() throws RemoteException {

  }

  public void setSessionContext(final SessionContext arg0) throws RemoteException {
    this.ctx = arg0;
  }

  public ProcessInstanceUUID copyProcessInstance(ProcessInstanceUUID instanceUUID, Map<String, Object> processVariables, Collection<InitialAttachment> attachments) throws RemoteException, InstanceNotFoundException,
      VariableNotFoundException {
    return getAPI().copyProcessInstance(instanceUUID, processVariables, attachments);
  }
  
  public ProcessInstanceUUID copyProcessInstance(ProcessInstanceUUID instanceUUID, Map<String, Object> processVariables, Collection<InitialAttachment> attachments, Date restoreVariableValuesAtDate) throws RemoteException, InstanceNotFoundException,
      VariableNotFoundException {
    return getAPI().copyProcessInstance(instanceUUID, processVariables, attachments, restoreVariableValuesAtDate);
  }

  public ProcessInstanceUUID instantiateProcess(ProcessDefinitionUUID processDefinitionUUID, Map<String, Object> processVariables, Collection<InitialAttachment> attachments, List<String> startActivitiesNames) throws RemoteException, ProcessNotFoundException,
      VariableNotFoundException, ActivityNotFoundException {
    return getAPI().instantiateProcess(processDefinitionUUID, processVariables, attachments, startActivitiesNames);
  }

  public ActivityInstanceUUID startExecution(ProcessInstanceUUID instanceUUID, String activityName)
      throws RemoteException, InstanceNotFoundException, ActivityNotFoundException, VariableNotFoundException {
    return getAPI().startExecution(instanceUUID, activityName);
  }

  public void stopExecution(ProcessInstanceUUID instanceUUID, String activityName) throws RemoteException,
      InstanceNotFoundException, ActivityNotFoundException {
    getAPI().stopExecution(instanceUUID, activityName);
  }

  public ProcessInstanceUUID instantiateProcess(ProcessDefinitionUUID processDefinitionUUID,
      Map<String, Object> processVariables, Collection<InitialAttachment> attachments,
      List<String> startActivitiesNames, String instanceInitiator) throws RemoteException, ProcessNotFoundException,
      VariableNotFoundException, ActivityNotFoundException {
    return getAPI().instantiateProcess(processDefinitionUUID, processVariables, attachments, startActivitiesNames, instanceInitiator);
  }

}
