/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.internal;

import org.ow2.bonita.facade.CommandAPI;
import org.ow2.bonita.facade.ManagementAPI;
import org.ow2.bonita.facade.QueryDefinitionAPI;
import org.ow2.bonita.facade.QueryRuntimeAPI;
import org.ow2.bonita.facade.RuntimeAPI;

/**
 *  Helper class giving access to {@link QueryDefinitionAPI}, {@link QueryRuntimeAPI},
 *  {@link ManagementAPI}, {@link RuntimeAPI} and {@link CommandAPI} interfaces.
 *
 */
public interface InternalAPIAccessor extends InternalQueryAPIAccessor {

  /**
   * To get the RuntimeAPI interface.
   * @return the interface RuntimeAPI.
   */
  InternalRuntimeAPI getRuntimeAPI();

  /**
   * To get the ManagementAPI interface.
   * @return the interface ManagementAPI.
   */
  InternalManagementAPI getManagementAPI();

  /**
   * To get the CommandAPI interface.
   * @return the interface CommandAPI.
   */
  InternalCommandAPI getCommandAPI();

  /**
   * To get the WebAPI interface.
   * @return the interface WebAPI.
   */
  InternalWebAPI getWebAPI();

  /**
   * To get the IdentityAPI interface.
   * @return the interface IdentityAPI.
   */
  InternalIdentityAPI getIdentityAPI();

  /**
   * To get the RepairAPI interface.
   * @return the interface RepairAPI.
   */
  InternalRepairAPI getRepairAPI();
}
