/**
 * Copyright (C) 2009  BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.internal;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Date;
import java.util.List;

/**
 * 
 * @author Matthieu Chaffotte
 *
 */
public interface InternalBAMAPI extends Remote {

  int getNumberOfOverdueSteps(String queryList) throws RemoteException;
  int getNumberOfStepsAtRisk(int remainingDays, String queryList) throws RemoteException;
  int getNumberOfOpenSteps(String queryList) throws RemoteException;

  int getNumberOfUserOverdueSteps(String queryList) throws RemoteException;
  int getNumberOfUserStepsAtRisk(int remainingDays, String queryList) throws RemoteException;
  int getNumberOfUserOpenSteps(String queryList) throws RemoteException;

  List<Integer> getNumberOfFinishedCasesPerDay(Date since, String queryList) throws RemoteException;
  List<Integer> getNumberOfExecutingCasesPerDay(Date since, String queryList) throws RemoteException;
  List<Integer> getNumberOfOpenStepsPerDay(Date since, String queryList) throws RemoteException;

  int getNumberOfUserOpenSteps(int priority, String queryList) throws RemoteException;
  int getNumberOfUserFinishedSteps(int priority, Date since, String queryList) throws RemoteException;
  int getNumberOfFinishedSteps(int priority, Date since, String queryList) throws RemoteException;
  int getNumberOfOpenSteps(int priority, String queryList) throws RemoteException;
}
