/**
 * Copyright (C) 2010  BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.runtime.impl;

import java.util.Date;

import org.ow2.bonita.facade.runtime.WebUser;
import org.ow2.bonita.util.Misc;

public class WebUserImpl implements WebUser {

  private static final long serialVersionUID = 6274393267555465164L;
  
  protected long dbid;
  protected String name;
  protected long lastAccessDate;
  
  protected WebUserImpl() { }
  
  public WebUserImpl(final String name) {
    super();
    this.name = name;
  }

  public WebUserImpl(final WebUser src) {
    this.name = src.getName();
    this.lastAccessDate = Misc.getTime(src.getLastAccessDate());
  }
  
  public Date getLastAccessDate() {
    return Misc.getDate(lastAccessDate);
  }

  public void setLastAccessDate(Date lastAccessDate) {
    this.lastAccessDate = Misc.getTime(lastAccessDate);
  }
  
  public String getName() {
    return this.name;
  }

}
