package org.ow2.bonita.runtime.event;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.ow2.bonita.env.Environment;
import org.ow2.bonita.services.EventService;
import org.ow2.bonita.util.Command;
import org.ow2.bonita.util.EnvTool;

public class GetNextDueDateCmd implements Command<Long> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = Logger.getLogger(GetNextDueDateCmd.class.getName());

  public Long execute(Environment environment) throws Exception {
    Long nextDueDate = null;
    if (LOG.isLoggable(Level.FINE)) {
      LOG.fine("getting next due date...");
    }
    EventService eventService = EnvTool.getEventService();
    nextDueDate = eventService.getNextDueDate();
    if (LOG.isLoggable(Level.FINE)) {
      LOG.fine("next due date is " + nextDueDate);
    }
    return nextDueDate;
  }
}
