/**
 * Copyright (C) 2010  BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.services;

import java.util.List;
import java.util.Set;

import org.ow2.bonita.facade.privilege.PrivilegePolicy;
import org.ow2.bonita.facade.privilege.Rule;
import org.ow2.bonita.facade.privilege.Rule.RuleType;

/**
 * @author Nicolas Chabanoles
 * 
 */
public interface PrivilegeService {
  
  Rule getRule(String name);

  Set<Rule> getRules();
  
  Set<Rule> getRules(Set<String> rulesName);

  void addRule(Rule rule);

  void deleteRule(Rule rule);

  PrivilegePolicy getDefaultPolicy();
  
  void setDefaultPolicy(PrivilegePolicy newPolicy);

  Set<Rule> getRulesByType(RuleType... ruleTypes);
  
  Set<Rule> getApplicableRules(String entityID, RuleType ruleType);
  
  Set<Rule> getAllApplicableRules(String entityID);

  List<Rule> getRules(RuleType ruleType, int fromIndex, int pageSige);
  
  Set<String> getExceptions(String entityID, RuleType ruleType);

  long getNumberOfRules(RuleType ruleType);

}
