/**
 * Copyright (C) 2010  BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.util;

public final class BonitaConstants {

  private BonitaConstants() { }
  
  public static final String LOGGING_PROPERTY = "java.util.logging.config.file";
  public static final String JAAS_PROPERTY = "java.security.auth.login.config";
  public static final String ENVIRONMENT_PROPERTY = "org.ow2.bonita.environment";
  public static final String API_TYPE_PROPERTY = "org.ow2.bonita.api-type";
  public static final String INITIAL_CONTEXT_FACTORY_PROPERTY = "java.naming.factory.initial";
  public static final String PROVIDER_URL_PROPERTY = "java.naming.provider.url";
  public static final String SYSTEM_USER = "SYSTEM";
  public static final String JEE_SERVER_PROPERTY = "org.ow2.bonita.test.jee.server";
  
  //used in examples/tests
  public static final String LOGIN_MODE_PROPERTY = "login.mode";
  public static final String LOGIN_MODE_TEST = "test";
  public static final String LOGIN_MODE_EXAMPLE = "example";
  
  public static final int MAX_QUERY_SIZE = 500;
  public static final int MAX_LIST_SIZE = 2500;
  public static final String TIMER_EVENT_PREFIX = "**bonita_timer**-";
  public static final String DEADLINE_EVENT_PREFIX = "**bonita_deadline**-";
  public static final String ASYNC_EVENT_PREFIX = "**bonita_async**-";
  
}
